Attribute VB_Name = "modWindowProc"
Option Explicit
Public m_colWindowCallBacks As Collection
Public Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetSystemMenu Lib "user32" (ByVal hwnd As Long, ByVal bRevert As Long) As Long
Public Declare Function IsMenu Lib "user32" (ByVal hMenu As Long) As Long
Public m_gl_BlaTestProcHandle As Long
Public Const GWL_WNDPROC = (-4)
Public Const GWL_HINSTANCE = (-6)
Public Enum WindowsMessages
    WM_ACTIVATE = &H6
    WM_ACTIVATEAPP = &H1C
    WM_ASKCBFORMATNAME = &H30C
    WM_CANCELJOURNAL = &H4B
    WM_CANCELMODE = &H1F
    WM_CHANGECBCHAIN = &H30D
    WM_CHAR = &H102
    WM_CHARTOITEM = &H2F
    WM_CHILDACTIVATE = &H22
    WM_CLEAR = &H303
    WM_CLOSE = &H10
    WM_COMMAND = &H111
    WM_COMPACTING = &H41
    WM_COMPAREITEM = &H39
    WM_COPY = &H301
    WM_COPYDATA = &H4A
    WM_CREATE = &H1
    WM_CTLCOLORBTN = &H135
    WM_CTLCOLORDLG = &H136
    WM_CTLCOLOREDIT = &H133
    WM_CTLCOLORLISTBOX = &H134
    WM_CTLCOLORMSGBOX = &H132
    WM_CTLCOLORSCROLLBAR = &H137
    WM_CTLCOLORSTATIC = &H138
    WM_CUT = &H300
    WM_DEADCHAR = &H103
    WM_DELETEITEM = &H2D
    WM_DESTROY = &H2
    WM_DESTROYCLIPBOARD = &H307
    WM_DEVMODECHANGE = &H1B
    WM_DRAWCLIPBOARD = &H308
    WM_DRAWITEM = &H2B
    WM_DROPFILES = &H233
    WM_ENABLE = &HA
    WM_ENDSESSION = &H16
    WM_ENTERIDLE = &H121
    WM_ENTERMENULOOP = &H211
    WM_ERASEBKGND = &H14
    WM_EXITMENULOOP = &H212
    WM_FONTCHANGE = &H1D
    WM_GETDLGCODE = &H87
    WM_GETFONT = &H31
    WM_GETHOTKEY = &H33
    WM_GETMINMAXINFO = &H24
    WM_GETTEXT = &HD
    WM_GETTEXTLENGTH = &HE
    WM_HOTKEY = &H312
    WM_HSCROLL = &H114
    WM_HSCROLLCLIPBOARD = &H30E
    WM_ICONERASEBKGND = &H27
    WM_INITDIALOG = &H110
    WM_INITMENU = &H116
    WM_INITMENUPOPUP = &H117
    WM_KEYDOWN = &H100
    WM_KEYFIRST = &H100
    WM_KEYLAST = &H108
    WM_KEYUP = &H101
    WM_KILLFOCUS = &H8
    WM_LBUTTONDBLCLK = &H203
    WM_LBUTTONDOWN = &H201
    WM_LBUTTONUP = &H202
    WM_MBUTTONDBLCLK = &H209
    WM_MBUTTONUP = &H208
    WM_MBUTTONDOWN = &H207
    WM_MDIACTIVATE = &H222
    WM_MDICASCADE = &H227
    WM_MDICREATE = &H220
    WM_MDIDESTROY = &H221
    WM_MDIGETACTIVE = &H229
    WM_MDIICONARRANGE = &H228
    WM_MDIMAXIMIZE = &H225
    WM_MDINEXT = &H224
    WM_MDIREFRESHMENU = &H234
    WM_MDIRESTORE = &H223
    WM_MDISETMENU = &H230
    WM_MDITILE = &H226
    WM_MEASUREITEM = &H2C
    WM_MENUCHAR = &H120
    WM_MENUSELECT = &H11F
    WM_MOUSEACTIVATE = &H21
    WM_MOUSEFIRST = &H200
    WM_MOUSELAST = &H209
    WM_MOUSEMOVE = &H200
    WM_MOVE = &H3
    WM_NCACTIVATE = &H86
    WM_NCCALCSIZE = &H83
    WM_NCCREATE = &H81
    WM_NCDESTROY = &H82
    WM_NCHITTEST = &H84
    WM_NCLBUTTONDBLCLK = &HA3
    WM_NCLBUTTONDOWN = &HA1
    WM_NCLBUTTONUP = &HA2
    WM_NCMBUTTONDBLCLK = &HA9
    WM_NCMBUTTONDOWN = &HA7
    WM_NCMBUTTONUP = &HA8
    WM_NCMOUSEMOVE = &HA0
    WM_NCPAINT = &H85
    WM_NCRBUTTONDBLCLK = &HA6
    WM_NCRBUTTONDOWN = &HA4
    WM_NCRBUTTONUP = &HA5
    WM_NEXTDLGCTL = &H28
    WM_NULL = &H0
    WM_PAINT = &HF
    WM_PAINTCLIPBOARD = &H309
    WM_PAINTICON = &H26
    WM_PALETTECHANGED = &H311
    WM_PALETTEISCHANGING = &H310
    WM_PARENTNOTIFY = &H210
    WM_PASTE = &H302
    WM_PENWINFIRST = &H380
    WM_PENWINLAST = &H38F
    WM_POWER = &H48
    WM_QUERYDRAGICON = &H37
    WM_QUERYENDSESSION = &H11
    WM_QUERYNEWPALETTE = &H30F
    WM_QUERYOPEN = &H13
    WM_QUEUESYNC = &H23
    WM_QUIT = &H12
    WM_RBUTTONDBLCLK = &H206
    WM_RBUTTONDOWN = &H204
    WM_RBUTTONUP = &H205
    WM_RENDERALLFORMATS = &H306
    WM_RENDERFORMAT = &H305
    WM_SETCURSOR = &H20
    WM_SETFOCUS = &H7
    WM_SETFONT = &H30
    WM_SETHOTKEY = &H32
    WM_SETREDRAW = &HB
    WM_SETTEXT = &HC
    WM_SHOWWINDOW = &H18
    WM_SIZE = &H5
    WM_SIZECLIPBOARD = &H30B
    WM_SPOOLERSTATUS = &H2A
    WM_SYSCHAR = &H106
    WM_SYSCOLORCHANGE = &H15
    WM_SYSCOMMAND = &H112
    WM_SYSDEADCHAR = &H107
    WM_SYSKEYDOWN = &H104
    WM_SYSKEYUP = &H105
    WM_TIMECHANGE = &H1E
    WM_TIMER = &H113
    WM_UNDO = &H304
    WM_USER = &H400
    WM_VKEYTOITEM = &H2E
    WM_VSCROLL = &H115
    WM_VSCROLLCLIPBOARD = &H30A
    WM_WINDOWPOSCHANGED = &H47
    WM_WINDOWPOSCHANGING = &H46
    WM_WININICHANGE = &H1A
End Enum
Public Enum SystemCommands
    SC_MOVE = &HF012&
    SC_CLOSE = &HF060&
    SC_POPUPKEY = &HF100&
    SC_POPUPMOUSE = &HF093&
End Enum

Public Function WindowProcedure(ByVal WindowHandle As Long, ByVal wMsg As WindowsMessages, ByVal wParam As Long, ByVal lOtherData As Long) As Long
    Dim m_cwnWindow As CWindow
    Dim m_booChange As Boolean
    Dim m_lngValue As Long
    Static LastWindow As CWindow
    Set m_cwnWindow = GetWindow(WindowHandle)
    If m_cwnWindow Is Nothing Then
        Debug.Print "Nothing found"
        WindowProcedure = DefWindowProc(WindowHandle, wMsg, wParam, lOtherData)
    Else
        m_cwnWindow.WindowList.OnCall wMsg, wParam, lOtherData, m_lngValue
        WindowProcedure = m_lngValue
    End If
End Function

Private Sub Main()
    Set m_colWindowCallBacks = New Collection
    frmTest.Show
End Sub

Public Sub AddWindow(Window As CWindow)
    m_colWindowCallBacks.Add Window
End Sub

Public Sub RemoveWindow(Window As CWindow)
    Dim m_cwnWindow As CWindow
    Dim m_lngIndex As Long
    For Each m_cwnWindow In m_colWindowCallBacks
        m_lngIndex = m_lngIndex + 1
        If m_cwnWindow Is Window Then
            m_colWindowCallBacks.Remove m_lngIndex
            Exit Sub
        End If
    Next
End Sub

Public Function GetWindow(hwnd As Long) As CWindow
    Dim m_cwnWindow As CWindow
    Dim m_lngIndex As Long
    For m_lngIndex = 1 To m_colWindowCallBacks.Count
        Set m_cwnWindow = m_colWindowCallBacks(m_lngIndex)
        If m_cwnWindow.Window = hwnd And m_cwnWindow.Hooked Then
            Set GetWindow = m_cwnWindow.WindowList.FirstIndex
            Exit Function
        End If
    Next
End Function

Public Function AddressOfItem(Item As Long)
    AddressOfItem = Item
End Function
Public Function LoWord(DoubleWordValue As Long) As Long
    '//Converts the double word into a single word value and returns
    '//the loword section.
    LoWord = DoubleWordValue Mod &H10000
End Function

Public Function WindowProc2(ByVal WindowHandle As Long, ByVal wMsg As WindowsMessages, ByVal wParam As Long, ByVal lOtherData As Long) As Long
    WindowProc2 = CallWindowProc(m_gl_BlaTestProcHandle, WindowHandle, wMsg, wParam, lOtherData)
End Function
