VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CWindowList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Dim m_colWindows As Collection
Private m_booInCall As Boolean

Public Function AddWindow(Window As CWindow)
    RemoveWindow Window
    If m_colWindows.Count > 0 Then
        m_colWindows.Add Window, , 1
    Else
        m_colWindows.Add Window
    End If
    Set AddWindow = Window
End Function

Public Sub RemoveWindow(Window As CWindow)
    Dim m_cwdWindow As CWindow
    Dim m_lngLoop As Long
    For Each m_cwdWindow In Me
        m_lngLoop = m_lngLoop + 1
        If m_cwdWindow Is Window Then
            m_colWindows.Remove m_lngLoop
        End If
    Next
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = m_colWindows.[_NewEnum]
End Property

Public Property Get Count() As Long
    Count = m_colWindows.Count
End Property

Public Sub Remove(Index As Long)
    m_colWindows.Remove Index
End Sub

Public Sub OnCall(ByRef Message As WindowsMessages, ByRef wParam As Long, ByRef lOtherData As Long, ByRef ReturnValue As Long)
    Dim m_cwdWindow As CWindow
    m_booInCall = True
    For Each m_cwdWindow In Me
        m_cwdWindow.WindowProcedure Message, wParam, lOtherData, ReturnValue
    Next
    m_booInCall = False
End Sub

Public Function FirstIndex() As CWindow
Attribute FirstIndex.VB_UserMemId = 0
    Set FirstIndex = m_colWindows.Item(1)
End Function

Private Sub Class_Initialize()
    Set m_colWindows = New Collection
End Sub

Private Sub Class_Terminate()
    Set m_colWindows = Nothing
End Sub

Public Function LastIndex() As CWindow
    Set LastIndex = m_colWindows(Count)
End Function

Public Function ReturnWindowIndex(Window As CWindow) As Long
    Dim m_cwdWindow As CWindow
    Dim m_lngIndex As Long
    For Each m_cwdWindow In m_colWindows
        m_lngIndex = m_lngIndex + 1
        If m_cwdWindow Is Window Then
            ReturnWindowIndex = m_lngIndex
            Exit Function
        End If
    Next
End Function

Public Property Get Item(Index As Long) As CWindow
    Set Item = m_colWindows(Index)
End Property

Friend Property Get InCall() As Boolean
    InCall = m_booInCall
End Property
